/*
* Copyright 2016 Red Hat, Inc. and/or its affiliates.
*  
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*  
*    http://www.apache.org/licenses/LICENSE-2.0
*  
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package org.kie.workbench.common.dmn.api.definition.adapter.binding;

import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionAdapterProxy;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory;

import javax.annotation.Generated;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionAdapter;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionAdapterProxy;

@Generated("org.kie.workbench.common.stunner.core.processors.definition.BindableDefinitionAdapterGenerator")
@ApplicationScoped
public class DMNDefinitionSetDefinitionAdapterImpl extends org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionAdapterProxy<Object> {

    private static final Map<Class, Class> baseTypes = new HashMap<Class, Class>(2) {{
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocumentModel.class, org.kie.workbench.common.dmn.api.definition.model.LiteralExpression.class );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocument.class, org.kie.workbench.common.dmn.api.definition.model.LiteralExpression.class );
    }};

    private static final Map<Class, String> idFieldNames = new HashMap<Class, String>(0) {{
    }};

    private static final Map<Class, String> categoryFieldNames = new HashMap<Class, String>(23) {{
            put( org.kie.workbench.common.dmn.api.definition.model.TextAnnotation.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClauseLiteralExpression.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpression.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.ImportedValues.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.NOPDomainObject.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClauseLiteralExpression.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClause.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.DMNDiagram.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.InputData.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItemPrimary.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.AuthorityRequirement.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocument.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.Association.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.UnaryTests.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocumentModel.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.DecisionService.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItem.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.Decision.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeRequirement.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationRequirement.class, "stunnerCategory" );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClause.class, "stunnerCategory" );
    }};

    private static final Map<Class, String> titleFieldNames = new HashMap<Class, String>(0) {{
    }};

    private static final Map<Class, String> descriptionFieldNames = new HashMap<Class, String>(0) {{
    }};

    private static final Map<Class, String> labelsFieldNames = new HashMap<Class, String>(23) {{
              put( org.kie.workbench.common.dmn.api.definition.model.TextAnnotation.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.InputClauseLiteralExpression.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpression.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.ImportedValues.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.NOPDomainObject.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.OutputClauseLiteralExpression.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.OutputClause.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.DMNDiagram.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.InputData.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.InformationItemPrimary.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.AuthorityRequirement.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocument.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.Association.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.UnaryTests.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocumentModel.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.DecisionService.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.InformationItem.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.Decision.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeRequirement.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.InformationRequirement.class, "stunnerLabels" );
              put( org.kie.workbench.common.dmn.api.definition.model.InputClause.class, "stunnerLabels" );
    }};

    private static final Map<Class, Class> graphFactoryFieldNames = new HashMap<Class, Class>(23) {{
            put( org.kie.workbench.common.dmn.api.definition.model.TextAnnotation.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClauseLiteralExpression.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpression.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.ImportedValues.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.NOPDomainObject.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClauseLiteralExpression.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClause.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.DMNDiagram.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.InputData.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItemPrimary.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.AuthorityRequirement.class, org.kie.workbench.common.stunner.core.factory.graph.EdgeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocument.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.Association.class, org.kie.workbench.common.stunner.core.factory.graph.EdgeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.UnaryTests.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocumentModel.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.DecisionService.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItem.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.Decision.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeRequirement.class, org.kie.workbench.common.stunner.core.factory.graph.EdgeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationRequirement.class, org.kie.workbench.common.stunner.core.factory.graph.EdgeFactory.class );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClause.class, org.kie.workbench.common.stunner.core.factory.graph.NodeFactory.class );
    }};

    private static final Map<Class, Set<String>> propertySetsFieldNames = new HashMap<Class, Set<String>>(9) {{
           put( org.kie.workbench.common.dmn.api.definition.model.TextAnnotation.class, new HashSet<String>() {{
                    add ( "backgroundSet" );
                    add ( "fontSet" );
                    add ( "dimensionsSet" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.DecisionService.class, new HashSet<String>() {{
                    add ( "variable" );
                    add ( "backgroundSet" );
                    add ( "fontSet" );
                    add ( "dimensionsSet" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel.class, new HashSet<String>() {{
                    add ( "variable" );
                    add ( "backgroundSet" );
                    add ( "fontSet" );
                    add ( "dimensionsSet" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource.class, new HashSet<String>() {{
                    add ( "backgroundSet" );
                    add ( "fontSet" );
                    add ( "dimensionsSet" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.Decision.class, new HashSet<String>() {{
                    add ( "variable" );
                    add ( "backgroundSet" );
                    add ( "fontSet" );
                    add ( "dimensionsSet" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.OutputClause.class, new HashSet<String>() {{
                    add ( "outputValues" );
                    add ( "defaultOutputEntry" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.InputClause.class, new HashSet<String>() {{
                    add ( "inputExpression" );
                    add ( "inputValues" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.DMNDiagram.class, new HashSet<String>() {{
                    add ( "definitions" );
            }} );
           put( org.kie.workbench.common.dmn.api.definition.model.InputData.class, new HashSet<String>() {{
                    add ( "variable" );
                    add ( "backgroundSet" );
                    add ( "fontSet" );
                    add ( "dimensionsSet" );
            }} );
    }};

    private static final Map<Class, Set<String>> propertiesFieldNames = new HashMap<Class, Set<String>>(19) {{
            put( org.kie.workbench.common.dmn.api.definition.model.TextAnnotation.class, new HashSet<String>() {{
                add ( "text" );
                add ( "textFormat" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClauseLiteralExpression.class, new HashSet<String>() {{
                add ( "typeRefHolder" );
                add ( "text" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel.class, new HashSet<String>() {{
                add ( "linksHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpression.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.ImportedValues.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClauseLiteralExpression.class, new HashSet<String>() {{
                add ( "text" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClause.class, new HashSet<String>() {{
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.DMNDiagram.class, new HashSet<String>() {{
                add ( "id" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InputData.class, new HashSet<String>() {{
                add ( "linksHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItemPrimary.class, new HashSet<String>() {{
                add ( "typeRefHolder" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocument.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.Association.class, new HashSet<String>() {{
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.UnaryTests.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocumentModel.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.DecisionService.class, new HashSet<String>() {{
                add ( "dividerLineY" );
                add ( "linksHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItem.class, new HashSet<String>() {{
                add ( "typeRefHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource.class, new HashSet<String>() {{
                add ( "type" );
                add ( "locationURI" );
                add ( "linksHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.Decision.class, new HashSet<String>() {{
                add ( "question" );
                add ( "allowedAnswers" );
                add ( "linksHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClause.class, new HashSet<String>() {{
                add ( "id" );
                add ( "description" );
            }} );
    }};

    private static final Map<org.kie.workbench.common.stunner.core.definition.property.PropertyMetaTypes, Class> metaPropertyTypes = new HashMap<org.kie.workbench.common.stunner.core.definition.property.PropertyMetaTypes, Class>(4) {{
            put( org.kie.workbench.common.stunner.core.definition.property.PropertyMetaTypes.HEIGHT, org.kie.workbench.common.dmn.api.property.dimensions.Height.class );
            put( org.kie.workbench.common.stunner.core.definition.property.PropertyMetaTypes.NAME, org.kie.workbench.common.dmn.api.property.dmn.Name.class );
            put( org.kie.workbench.common.stunner.core.definition.property.PropertyMetaTypes.WIDTH, org.kie.workbench.common.dmn.api.property.dimensions.Width.class );
            put( org.kie.workbench.common.stunner.core.definition.property.PropertyMetaTypes.ID, org.kie.workbench.common.dmn.api.property.dmn.Id.class );
    }};

    private static final Map<Class, String> nameFields = new HashMap<Class, String>(6) {{
            put(org.kie.workbench.common.dmn.api.definition.model.TextAnnotation.class, "text");
            put(org.kie.workbench.common.dmn.api.definition.model.DecisionService.class, "name");
            put(org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel.class, "name");
            put(org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource.class, "name");
            put(org.kie.workbench.common.dmn.api.definition.model.Decision.class, "name");
            put(org.kie.workbench.common.dmn.api.definition.model.InputData.class, "name");
    }};

    protected DMNDefinitionSetDefinitionAdapterImpl() {
    }

    @Inject
    public DMNDefinitionSetDefinitionAdapterImpl(org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    @Override
    protected void setBindings(final BindableDefinitionAdapter<Object> adapter) {
        adapter.setBindings( metaPropertyTypes,
                baseTypes,
                propertySetsFieldNames,
                propertiesFieldNames,
                graphFactoryFieldNames,
                idFieldNames,
                labelsFieldNames,
                titleFieldNames,
                categoryFieldNames,
                descriptionFieldNames,
                nameFields);
    }

}
