/*
* Copyright 2016 Red Hat, Inc. and/or its affiliates.
*  
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*  
*    http://www.apache.org/licenses/LICENSE-2.0
*  
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package org.kie.workbench.common.dmn.api.definition.adapter.binding;

import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionSetAdapterProxy;

import javax.annotation.Generated;
import javax.enterprise.context.ApplicationScoped;
import java.lang.annotation.Annotation;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import javax.inject.Inject;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionSetAdapter;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionSetAdapterProxy;

@Generated("org.kie.workbench.common.stunner.core.processors.definitionset.BindableDefinitionSetAdapterGenerator")
@ApplicationScoped
public class DMNDefinitionSetDefinitionSetAdapterImpl extends org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableDefinitionSetAdapterProxy<Object> {

    private static final Map<Class, String> descriptionFieldNames = new HashMap<Class, String>(1) {{
            put( org.kie.workbench.common.dmn.api.DMNDefinitionSet.class, "description" );
    }};

    private static final Map<Class, Annotation> qualifiers = new HashMap<Class, Annotation>(1) {{
            put( org.kie.workbench.common.dmn.api.DMNDefinitionSet.class,
                new org.kie.workbench.common.dmn.api.qualifiers.DMNEditor() {
                    @Override
                    public Class<? extends Annotation> annotationType() {
                        return org.kie.workbench.common.dmn.api.qualifiers.DMNEditor.class;
                }
            });
    }};

    private static final Set<String> definitionIds = new HashSet<String>(21) {{
            add( "org.kie.workbench.common.dmn.api.definition.model.TextAnnotation" );
            add( "org.kie.workbench.common.dmn.api.definition.model.BusinessKnowledgeModel" );
            add( "org.kie.workbench.common.dmn.api.definition.model.LiteralExpression" );
            add( "org.kie.workbench.common.dmn.api.definition.model.ImportedValues" );
            add( "org.kie.workbench.common.dmn.api.definition.NOPDomainObject" );
            add( "org.kie.workbench.common.dmn.api.definition.model.OutputClause" );
            add( "org.kie.workbench.common.dmn.api.definition.model.DMNDiagram" );
            add( "org.kie.workbench.common.dmn.api.definition.model.InputData" );
            add( "org.kie.workbench.common.dmn.api.definition.model.InformationItemPrimary" );
            add( "org.kie.workbench.common.dmn.api.definition.model.Association" );
            add( "org.kie.workbench.common.dmn.api.definition.model.AuthorityRequirement" );
            add( "org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocument" );
            add( "org.kie.workbench.common.dmn.api.definition.model.LiteralExpressionPMMLDocumentModel" );
            add( "org.kie.workbench.common.dmn.api.definition.model.UnaryTests" );
            add( "org.kie.workbench.common.dmn.api.definition.model.DecisionService" );
            add( "org.kie.workbench.common.dmn.api.definition.model.InformationItem" );
            add( "org.kie.workbench.common.dmn.api.definition.model.KnowledgeSource" );
            add( "org.kie.workbench.common.dmn.api.definition.model.Decision" );
            add( "org.kie.workbench.common.dmn.api.definition.model.KnowledgeRequirement" );
            add( "org.kie.workbench.common.dmn.api.definition.model.InformationRequirement" );
            add( "org.kie.workbench.common.dmn.api.definition.model.InputClause" );
    }};

    private static final Map<Class, Class> graphFactoryTypes = new HashMap<Class, Class>(1) {{
        put( org.kie.workbench.common.dmn.api.DMNDefinitionSet.class, org.kie.workbench.common.dmn.api.factory.DMNGraphFactory.class );
        }};

    protected DMNDefinitionSetDefinitionSetAdapterImpl() {
    }

    @Inject
    public DMNDefinitionSetDefinitionSetAdapterImpl(org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    @Override
    protected void setBindings(final BindableDefinitionSetAdapter<Object> adapter) {
        adapter.setBindings( descriptionFieldNames, graphFactoryTypes, qualifiers, definitionIds );
    }

}
