/*
* Copyright 2016 Red Hat, Inc. and/or its affiliates.
*  
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*  
*    http://www.apache.org/licenses/LICENSE-2.0
*  
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package org.kie.workbench.common.dmn.api.definition.adapter.binding;

import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertyAdapterProxy;

import javax.annotation.Generated;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import java.util.HashMap;
import java.util.Map;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertyAdapter;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertyAdapterProxy;
import org.kie.workbench.common.stunner.core.definition.property.*;
import org.kie.workbench.common.stunner.core.definition.property.type.*;

@Generated("org.kie.workbench.common.stunner.core.processors.property.BindablePropertyAdapterGenerator")
@ApplicationScoped
public class DMNDefinitionSetPropertyAdapterImpl extends org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertyAdapterProxy<Object, Object> {

    private static final Map<Class, String> propValueFieldNames = new HashMap<Class, String>(22) {{
            put( org.kie.workbench.common.dmn.api.property.dmn.Question.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dimensions.Height.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dimensions.Width.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.DecisionServiceDividerLineY.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.background.BorderSize.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.DocumentationLinksHolder.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.ConstraintTypeProperty.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.LocationURI.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.TextFormat.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.font.FontFamily.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.background.BorderColour.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.KnowledgeSourceType.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.Id.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.Name.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.Text.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.QNameHolder.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.ExpressionLanguage.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.Description.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.font.FontSize.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.font.FontColour.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.background.BgColour.class, "value" );
            put( org.kie.workbench.common.dmn.api.property.dmn.AllowedAnswers.class, "value" );

    }};

    private static final Map<Class, String> propAllowedValuesFieldNames = new HashMap<Class, String>(0) {{
    }};

    private static final Map<Class, String> propTypeFieldNames = new HashMap<Class, String>(5) {{
              put( org.kie.workbench.common.dmn.api.property.dmn.QNameHolder.class, "type" );
              put( org.kie.workbench.common.dmn.api.property.dmn.DocumentationLinksHolder.class, "type" );
              put( org.kie.workbench.common.dmn.api.property.font.FontColour.class, "type" );
              put( org.kie.workbench.common.dmn.api.property.background.BgColour.class, "type" );
              put( org.kie.workbench.common.dmn.api.property.background.BorderColour.class, "type" );
    }};

    private static final Map<Class, PropertyType> propTypes = new HashMap<Class, PropertyType>(22) {{
            put( org.kie.workbench.common.dmn.api.property.dmn.Question.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dimensions.Height.class, new org.kie.workbench.common.stunner.core.definition.property.type.DoubleType() );
            put( org.kie.workbench.common.dmn.api.property.dimensions.Width.class, new org.kie.workbench.common.stunner.core.definition.property.type.DoubleType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.DecisionServiceDividerLineY.class, new org.kie.workbench.common.stunner.core.definition.property.type.DoubleType() );
            put( org.kie.workbench.common.dmn.api.property.background.BorderSize.class, new org.kie.workbench.common.stunner.core.definition.property.type.DoubleType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.ConstraintTypeProperty.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.LocationURI.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.TextFormat.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.font.FontFamily.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.KnowledgeSourceType.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.Id.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.Name.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.Text.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.ExpressionLanguage.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.Description.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
            put( org.kie.workbench.common.dmn.api.property.font.FontSize.class, new org.kie.workbench.common.stunner.core.definition.property.type.DoubleType() );
            put( org.kie.workbench.common.dmn.api.property.dmn.AllowedAnswers.class, new org.kie.workbench.common.stunner.core.definition.property.type.StringType() );
    }};

    private static final Map<Class, String> propCaptionFieldNames = new HashMap<Class, String>(0) {{
    }};

    private static final Map<Class, String> propDescriptionFieldNames = new HashMap<Class, String>(0) {{
    }};

    private static final Map<Class, String> propReadOnlyFieldNames = new HashMap<Class, String>(1) {{
            put( org.kie.workbench.common.dmn.api.property.dmn.Id.class, "readOnly" );
    }};

    private static final Map<Class, String> propOptionalFieldNames = new HashMap<Class, String>(0) {{
    }};

    protected DMNDefinitionSetPropertyAdapterImpl() {
    }

    @Inject
    public DMNDefinitionSetPropertyAdapterImpl(org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    @Override
    protected void setBindings(final BindablePropertyAdapter<Object, Object> adapter) {
        adapter.setBindings(    propTypeFieldNames,
                                propTypes,
                                propCaptionFieldNames,
                                propDescriptionFieldNames,
                                propReadOnlyFieldNames,
                                propOptionalFieldNames,
                                propValueFieldNames,
                                propAllowedValuesFieldNames );
    }

}
