/*
* Copyright 2016 Red Hat, Inc. and/or its affiliates.
*  
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*  
*    http://www.apache.org/licenses/LICENSE-2.0
*  
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package org.kie.workbench.common.dmn.api.definition.adapter.binding;

import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertySetAdapterProxy;

import javax.annotation.Generated;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertySetAdapter;
import org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertySetAdapterProxy;

@Generated("org.kie.workbench.common.stunner.core.processors.propertyset.BindablePropertySetAdapterGenerator")
@ApplicationScoped
public class DMNDefinitionSetPropertySetAdapterImpl extends org.kie.workbench.common.stunner.core.definition.adapter.binding.BindablePropertySetAdapterProxy<Object> {

    private static final Map<Class, String> nameFieldNames = new HashMap<Class, String>(0) {{

    }};

    private static final Map<Class, Set<String>> propertiesFieldNames = new HashMap<Class, Set<String>>(12) {{
            put( org.kie.workbench.common.dmn.api.definition.model.InputClauseLiteralExpression.class, new HashSet<String>() {{
                add ( "typeRefHolder" );
                add ( "text" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.Definitions.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "namespace" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InputClauseUnaryTests.class, new HashSet<String>() {{
                add ( "text" );
                add ( "constraintTypeProperty" );
            }} );
            put( org.kie.workbench.common.dmn.api.property.dimensions.DecisionServiceRectangleDimensionsSet.class, new HashSet<String>() {{
                add ( "width" );
                add ( "height" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItem.class, new HashSet<String>() {{
                add ( "typeRefHolder" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.property.dimensions.GeneralRectangleDimensionsSet.class, new HashSet<String>() {{
                add ( "width" );
                add ( "height" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClauseUnaryTests.class, new HashSet<String>() {{
                add ( "text" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.ImportedValues.class, new HashSet<String>() {{
                add ( "expressionLanguage" );
                add ( "name" );
                add ( "id" );
                add ( "description" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.OutputClauseLiteralExpression.class, new HashSet<String>() {{
                add ( "text" );
            }} );
            put( org.kie.workbench.common.dmn.api.property.font.FontSet.class, new HashSet<String>() {{
                add ( "fontFamily" );
                add ( "fontColour" );
                add ( "fontSize" );
            }} );
            put( org.kie.workbench.common.dmn.api.definition.model.InformationItemPrimary.class, new HashSet<String>() {{
                add ( "typeRefHolder" );
            }} );
            put( org.kie.workbench.common.dmn.api.property.background.BackgroundSet.class, new HashSet<String>() {{
                add ( "bgColour" );
                add ( "borderColour" );
            }} );
    }};

    protected DMNDefinitionSetPropertySetAdapterImpl() {
    }

    @Inject
    public DMNDefinitionSetPropertySetAdapterImpl(org.kie.workbench.common.stunner.core.definition.adapter.binding.BindableAdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    @Override
    protected void setBindings( final BindablePropertySetAdapter<Object> adapter ) {

        adapter.setBindings( nameFieldNames, propertiesFieldNames );

    }

}
